"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SeedcodeCatalogosMhService = void 0;
const facturacion_db_1 = require("./data/facturacion-db");
class SeedcodeCatalogosMhService {
    constructor() {
        this.cat001AmbienteDeDestino = [
            ...facturacion_db_1.default.cat001_ambiente_de_destino,
        ];
        this.cat002TipoDeDocumento = [
            ...facturacion_db_1.default.cat002_tipo_de_documento,
        ];
        this.cat003ModeloDeFacturacion = [
            ...facturacion_db_1.default.cat003_modelo_de_facturacion,
        ];
        this.cat004TipoDeTransmision = [
            ...facturacion_db_1.default.cat004_tipo_de_transmision,
        ];
        this.cat005TipoDeContingencum = [
            ...facturacion_db_1.default.cat005_tipo_de_contingencia,
        ];
        this.cat006RetencionIvaMh = [
            ...facturacion_db_1.default.cat006_retencion_iva_mh,
        ];
        this.cat007TipoDeGeneracionDelD = [
            ...facturacion_db_1.default.cat007_tipo_de_generacion_del_d,
        ];
        this.cat008 = [...facturacion_db_1.default.cat008];
        this.cat009TipoDeEstablecimiento = [...facturacion_db_1.default.cat009_tipo_de_establecimiento];
        this.cat010CodigoDeServicioMedic = [...facturacion_db_1.default.cat010_codigo_de_servicio_medic];
        this.cat011TipoDeItem = [
            ...facturacion_db_1.default.cat011_tipo_de_item,
        ];
        this.cat012Departamento = [
            ...facturacion_db_1.default.cat012_departamento,
        ];
        this.cat013Municipio = [
            ...facturacion_db_1.default.cat013_municipio,
        ];
        this.cat014UnidadDeMedida = [
            ...facturacion_db_1.default.cat014_unidad_de_medida,
        ];
        this.cat015Tributo = [
            ...facturacion_db_1.default.cat015_tributo,
        ];
        this.cat016CondicionDeLaOperacio = [...facturacion_db_1.default.cat016_condicion_de_la_operacio];
        this.cat017FormaDePago = [
            ...facturacion_db_1.default.cat017_forma_de_pago,
        ];
        this.cat018Plazo = [...facturacion_db_1.default.cat018_plazo];
        this.cat019CodigoDeActividaEcono = [...facturacion_db_1.default.cat019_codigo_de_activida_econo];
        this.cat020Pai = [...facturacion_db_1.default.cat020_pais];
        this.cat021OtrosDocumentosAsociad = [...facturacion_db_1.default.cat021_otros_documentos_asociad];
        this.cat022TipoDeDocumentoDeIde = [
            ...facturacion_db_1.default.cat022_tipo_de_documento_de_ide,
        ];
        this.cat023TipoDeContingencum = [
            ...facturacion_db_1.default.cat023_tipo_de_contingencia,
        ];
        this.cat024TipoDeInvalidacion = [
            ...facturacion_db_1.default.cat024_tipo_de_invalidacion,
        ];
        this.cat025TituloAQueRemitenLos = [
            ...facturacion_db_1.default.cat025_titulo_a_que_remiten_los,
        ];
        this.cat026TipoDeDonacion = [
            ...facturacion_db_1.default.cat026_tipo_de_donacion,
        ];
        this.cat027RecintoFiscal = [
            ...facturacion_db_1.default.cat027_recinto_fiscal,
        ];
        this.cat028Regimen = [
            ...facturacion_db_1.default.cat028_regimen,
        ];
        this.cat029TipoDePersona = [
            ...facturacion_db_1.default.cat029_tipo_de_persona,
        ];
        this.cat030Transporte = [
            ...facturacion_db_1.default.cat030_transporte,
        ];
        this.cat031Incoterm = [
            ...facturacion_db_1.default.cat031_incoterm,
        ];
        this.cat032DomicilioFiscal = [
            ...facturacion_db_1.default.cat032_domicilio_fiscal,
        ];
    }
    get001AmbienteDeDestino() {
        return this.cat001AmbienteDeDestino;
    }
    get002TipoDeDocumento() {
        return this.cat002TipoDeDocumento;
    }
    get003ModeloDeFacturacion() {
        return this.cat003ModeloDeFacturacion;
    }
    get004TipoDeTransmision() {
        return this.cat004TipoDeTransmision;
    }
    get005TipoDeContingencum() {
        return this.cat005TipoDeContingencum;
    }
    get006RetencionIvaMh() {
        return this.cat006RetencionIvaMh;
    }
    get007TipoDeGeneracionDelD() {
        return this.cat007TipoDeGeneracionDelD;
    }
    get008() {
        return this.cat008;
    }
    get009TipoDeEstablecimiento() {
        return this.cat009TipoDeEstablecimiento;
    }
    get010CodigoDeServicioMedic() {
        return this.cat010CodigoDeServicioMedic;
    }
    get011TipoDeItem() {
        return this.cat011TipoDeItem;
    }
    get012Departamento() {
        return this.cat012Departamento;
    }
    get013Municipio(departamento) {
        if (!this.cat013Municipio) {
            return null;
        }
        return this.cat013Municipio.filter((municipio) => {
            return municipio.departamento === departamento;
        });
    }
    get014UnidadDeMedida() {
        return this.cat014UnidadDeMedida;
    }
    get015Tributo() {
        return this.cat015Tributo;
    }
    get016CondicionDeLaOperacio() {
        return this.cat016CondicionDeLaOperacio;
    }
    get017FormaDePago() {
        return this.cat017FormaDePago;
    }
    get018Plazo() {
        return this.cat018Plazo;
    }
    get019CodigoDeActividaEcono(name, page = 1, pageSize = 25) {
        if (!this.cat019CodigoDeActividaEcono) {
            return [];
        }
        let result = this.cat019CodigoDeActividaEcono;
        if (name) {
            const normalizedSearch = this.normalize(name.trim());
            result = result.filter((item) => {
                const normalizedValue = this.normalize(item.valores.trim());
                return normalizedValue.includes(normalizedSearch);
            });
        }
        const start = (page - 1) * pageSize;
        const end = start + pageSize;
        return result.slice(start, end);
    }
    get020Pais() {
        return this.cat020Pai;
    }
    get021OtrosDocumentosAsociad() {
        return this.cat021OtrosDocumentosAsociad;
    }
    get022TipoDeDocumentoDeIde() {
        return this.cat022TipoDeDocumentoDeIde;
    }
    get023TipoDeContingencum() {
        return this.cat023TipoDeContingencum;
    }
    get024TipoDeInvalidacion() {
        return this.cat024TipoDeInvalidacion;
    }
    get025TituloAQueRemitenLo() {
        return this.cat025TituloAQueRemitenLos;
    }
    get026TipoDeDonacion() {
        return this.cat026TipoDeDonacion;
    }
    get027TipoDePersona() {
        return this.cat027RecintoFiscal;
    }
    get028Regimen() {
        return this.cat028Regimen;
    }
    get029TipoDePersona() {
        return this.cat029TipoDePersona;
    }
    get030Transporte() {
        return this.cat030Transporte;
    }
    get031Incoterm() {
        return this.cat031Incoterm;
    }
    get032DomicilioFiscal() {
        return this.cat032DomicilioFiscal;
    }
    normalize(text) {
        return text
            .normalize('NFD')
            .replace(/[\u0300-\u036f]/g, '')
            .replace(/[\u00C0-\u00C5]/g, 'A')
            .replace(/[\u00E0-\u00E5]/g, 'a')
            .replace(/[\u00C8-\u00CB]/g, 'E')
            .replace(/[\u00E8-\u00EB]/g, 'e')
            .replace(/[\u00CC-\u00CF]/g, 'I')
            .replace(/[\u00EC-\u00EF]/g, 'i')
            .replace(/[\u00D2-\u00D6]/g, 'O')
            .replace(/[\u00F2-\u00F6]/g, 'o')
            .replace(/[\u00D9-\u00DC]/g, 'U')
            .replace(/[\u00F9-\u00FC]/g, 'u')
            .replace(/[\u00D1]/g, 'N')
            .replace(/[\u00F1]/g, 'n')
            .replace(/[^\w\s]/gi, '')
            .toLowerCase();
    }
}
exports.SeedcodeCatalogosMhService = SeedcodeCatalogosMhService;
//# sourceMappingURL=seedcode-catalogos-mh.service.js.map